<template>
  <div class="d-flex flex-column px-md-16 px-4 w-100">
    <div class="d-flex flex-row align-center justify-space-between w-100 py-8">
      <div class="d-flex flex-column">
        <h2>Dashboard</h2>
        <span>Generelle Informationen zu Daten.</span>
      </div>
    </div>

    <v-container class="pa-0">
      <v-row v-if="counts">
        <v-col cols="12" md="4" sm="12">
          <v-card
            class="pa-4"
            color="primary"
            title="Benutzer"
            :subtitle="counts.userCount + ' Benutzer'"
            link
            :to="'/users'"
          >
            <template v-slot:prepend>
              <v-icon size="x-large" icon="mdi-account-group" class="mr-2"></v-icon>
            </template>
          </v-card>
        </v-col>

        <v-col cols="12" md="4" sm="12">
          <v-card
            class="pa-4"
            color="primary"
            title="Rollen"
            :subtitle="counts.roleCount + ' Rollen'"
            link
            :to="'/roles'"
          >
            <template v-slot:prepend>
              <v-icon size="x-large" icon="mdi-badge-account" class="mr-2"></v-icon>
            </template>
          </v-card>
        </v-col>

        <v-col cols="12" md="4" sm="12">
          <v-card
            class="pa-4"
            color="primary"
            title="Rollen Berechtigungen"
            :subtitle="counts.roleRightCount + ' Rollen Berechtigungen'"
            link
            :to="'/role-rights'"
          >
            <template v-slot:prepend>
              <v-icon
                size="x-large"
                icon="mdi-badge-account-horizontal"
                class="mr-2"
              ></v-icon>
            </template>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, ref } from "vue";
import { CountResponse, api } from "../api";

const counts = ref<CountResponse>();

async function getCounts(): Promise<void> {
  const { data, status, statusText } = await api.statistics.getCounts();

  if (status !== 200) {
    console.error(statusText);
    return;
  }
  counts.value = data;
}

onMounted(getCounts);
</script>
